#include "main.h"
#include "parse.h"
#include "net.h"
#include "ext.h"

char opt,*host;

int main(int argc, char *argv[])
{
	int sock;
	port=DEF_PORT;
	tname="default.conf";
	tmpf="/tmp/b0rz.tmp";
	expand=udp=0;
	string=NULL;
	timeout=2;
	getch=0;
	
	while ((opt=getopt(argc,(void*)argv, "+s:c:l:up:eZt:h"))!=EOF)
    		switch(opt) {
		      case 'c': tname=optarg; break;
		      case 'l': lname=optarg; break;
		      case 'u': udp=1;break;
		      case 'p': port=optarg; break;
		      case 's': string=optarg;break;
		      case 'e': expand=1;break;
		      case 'Z': secret();break;
		      case 't': timeout=atoi(optarg);break;
		      case 'h': getch=1;break;
		      default:  print_help(argv[0]);
		}
	
        if (argc-optind!=1 && !expand)
		print_help(argv[0]);
	
	host=argv[optind];
	parse_conf(tname);

	sock = connectto(host,port);
	session(sock);
	b0rz_exit(0,1,sock);
	return 0; /* never to be reached */
}

void print_help(char *prog)
{
	printf("b0rz v. %s\n   usage: %s [options] host\nOptions:\n"
	       "   -c <file> Use alternative configuration file "
	       "(default: %s)\n"
	       "   -l <file> Write everything to output file instead\n" 
	       "      of stdout\n"
	       "   -p <port> (default: %s)\n"
	       "   -s <string> send just one string\n"
	       "      NOTE: use \\$ and \\\\x for special charecters\n"
	       "   -u UDP mode\n"
	       "   -e just expand/stdout %s file and exit\n"
	       "      (in this case other options are ignored)\n"
	       "   -t timeout (default: %d secs)\n"
	       "   -h getch on every send/recv\n",
	       VERSION,prog,tname,DEF_PORT,tname,timeout);
	exit(-1);
}

void b0rz_exit(int code, int state, int sock)
{
	unlink(tmpf);
	(state) ? (disconnect(sock)) : (0);
	exit(code);
}

void secret()
{
	printf("\x62\x30\x72\x7a\x20\x6d\x65\x61\x6e\x73\x20\x77\x6f"
	       "\x6c\x66\x20\x69\x6e\x20\x63\x68\x65\x63\x68\x65\x6e"
	       "\x20\x6c\x61\x6e\x67\x75\x61\x67\x65\x0a");
	b0rz_exit(0,0,0);
}
